! Transform and submit a strip of textured, lit vertices
! 
.globl _render_strip_wide
! int render_strip_wide(rendertarget, simplelitvert *, int vertcount, float lightx, float lighty,
!	float lightz, float lightw, float ambient)
!r0 sq target/debug ret
!r1 
!r2 sq write pos
!r3 vert strip command/end vert strip command
!r4 sq target [arg] sq toggle xor bit mask
!r5 vertlist read pos [arg]
!r6 vertcount [arg]
!fr0,fr1,fr2,fr3 vertex
!fr4,fr5,fr6,fr7 light vector [arg]
!fr8 ambient [arg]
!fr8,fr9,fr10,fr11 vertex normal
!fr12 ambient
!fr3 1/w
!fr13 const 0
#define x fr0
#define y fr1
#define z fr2
#define w fr3
#define lx fr4
#define ly fr5
#define lz fr6
#define lw fr7
#define nx fr8
#define ny fr9
#define nz fr10
#define nw fr11
#define ambient fr12
#define xy dr0
#define zw dr2
#define lxy dr4
#define lzw dr6
#define nxy dr8
#define nzw dr10
#define uv dr14
#define vec fv0
#define lvec fv4
#define nvec fv8

_render_strip_wide:

	pref @r5	!prefetch vertex
	mov #224,r3	!load const for vert command
	
	fmov.s fr12,@-r15	!push to stack so fr12 can hold ambient
	shll16 r3	!shift const to correct value
		
	fmov.s fr14,@-r15	!push to stack so fr14 can hold u

	mov r4,r0	!copy target sq to r0
	fmov.s fr15,@-r15	!push to stack so fr14 can hold v
	
	shll8 r3	!finish const shifting
 	fmov fr8,ambient	!move ambient to fr12
	
	fldi0 fr9	!load const for clamping above zero
	xor #32, r0	!switch to other sq

	!for some reason, having a nop down there instead of the fschg is faster...
	bra .trmwidesubmitstart	!skip over submitting empty sq
	fschg		!!!!!!!!!!!!double loads
.align 2
.trmwidesubmitloop:
	pref @r0	!submit current sq
	fschg		!!!!!!!!!!!!!double loads
.align 2
.trmwidesubmitstart:
	fmov @r5+,dr0	!load vertex x,y
	xor #32, r0	!switch to other sq

	fmov @r5+,dr2	!load vertex z,w
	mov r0,r2	!copy target sq to r2 for write pos

	fmov @r5+,dr8	!load normal x,y
	add #4*4,r2	!move to vertex write pos to sq's uv
	
	ftrv xmtrx,fv0	!transform
	fmov @r5+,nzw	!load normal z,w
	
!	pref @r5	!prefetch next vertex
	!nop
	
	fipr lvec,nvec	!do dot product between normal and light	
	
	fmov @r5+,uv	!load texture u,v
	!nop
	
	add #4*2,r2	!move write pos to sq intensity
	
!	pref @r5	!prefetch next vertex
	fmov uv,@r2	!write texture u,v
	
	
	!fldi1	z	![PERSPECTIVE] set fr2 to 1 for 1/w calc
	fmul w,w
	!fdiv w,z	!start 1/w calc
	
	mov.l r3,@r0	!write vertex command const to sq
	fcmp/gt lw, nw	!is the light more than zero?

	fschg		!!!!!!!!!!!!single writes
	fsrra w
	bt .trmwidelightclamped	!if it's more than zero, don't lower it, just add ambient

	fldi0 nw	!if it's less than zero, make it zero (clamp it so it's more than zero)

.trmwidelightclamped:
	fadd ambient,nw	!add ambient
	dt r6		!one less vertex to send, check loop for later jump

	fmov.s nw,@r2	!write intensity to sq
	fmul w,fr1	!calc y/w

	add #-4*3,r2	!move sq write pos for vertex z write
	fmul w,fr0	!calc x/w

	fmov.s w,@r2	!write 1/w to sq
	!

	fmov.s fr1,@-r2	!write y/w to sq
	!

	bf/s .trmwidesubmitloop	!if there's stuff left, keep sending ((loop checked above with bt))
	fmov.s fr0,@-r2	![[[DELAYSLOT]]] write x/w to sq


!fschg
!fmov.s @r15+,fr13	!pop stack back
!fmov.s @r15+,fr12	!pop stack back
!rts
!nop

	!we are on the last triangle, switch to end strip command and submit
	mov #240,r3	!load const for end vert list
    fmov.s @r15+,fr15	!pop stack back

	shll16 r3	!shift const to correct value
    fmov.s @r15+,fr14	!pop stack back

	shll8 r3	!finish const shifting
!   fmov.s @r15+,fr13	!pop stack back

	mov.l r3,@r0	!set end of list value at sq start
	fmov.s @r15+,fr12	!pop stack back
	
	rts		!return
	pref @r0	![[[DELAYSLOT]]]submit sq, send last triangle to end list
	nop
